--- events.c	2005-01-11 05:53:06.000000000 +0100
+++ events-new.c	2005-06-09 12:17:16.579824000 +0200
@@ -322,11 +322,14 @@
 		printf("\tCurrent Interleave Block: %d\n",current_interleave_block);
 #endif
 
-		for(interleave_block_index=0;interleave_block_index<scheduling_info.service_interleave_factor && temp_service!=NULL;temp_service=temp_service->next,interleave_block_index++){
+		/* skip this service if it shouldn't be scheduled */
+		if(temp_service->should_be_scheduled==FALSE)
+			{
+			temp_service=temp_service->next;
+			continue;
+			}
 
-			/* skip this service if it shouldn't be scheduled */
-			if(temp_service->should_be_scheduled==FALSE)
-				continue;
+		for(interleave_block_index=0;interleave_block_index<scheduling_info.service_interleave_factor && temp_service!=NULL;temp_service=temp_service->next,interleave_block_index++){
 
 			/* skip services that are already scheduled (from retention data) */
 			if(temp_service->next_check!=(time_t)0)
